/******************************************************************************
 * File: MRUStringList.impl.h
 * Date: 01.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "MRUStringList.h"

template<typename ContainerType>
ContainerType MRUStringList::find(QString entry, ContainerType begin, ContainerType end)
{
	// When comparing paths, convert backslashes to slashes first
	if (_isPathList)
		entry.replace('\\', '/');

	for (auto it = begin; it != end; ++it)
	{
		QString listEntry = *it;

		if (_isPathList)
			listEntry.replace('\\', '/');

		if (entry.compare(listEntry, _isCaseSensitive ? Qt::CaseSensitive : Qt::CaseInsensitive) == 0)
			return it;
	}

	return end;
}
