/******************************************************************************
 * File: PropertyID.h
 * Date: 12.1.2018
 *****************************************************************************/

#ifndef PROPERTYID_H
#define PROPERTYID_H

#include <QString>

namespace grndr
{
	class PropertyID final : public QString
	{
	public:
		static const char* None; /* Invalid property */
		static const char* Default;

		/* Block properties */
		static const char* ImageReference;
		static const char* Threshold;
		static const char* TargetValue;
		static const char* Invert;
		static const char* ImageTags;

		/* DraftItem properties */
		static const char* PrimaryColor;
		static const char* Position;
		static const char* EndPosition;
		static const char* Size;
		static const char* Width;
		static const char* Margin;
		static const char* Solid;
		static const char* HasDirection;
		static const char* Direction;
		static const char* ShowBox;
		static const char* ImageTagsAllotment;

	public:
		using QString::QString;

		PropertyID() = default;
		PropertyID(const PropertyID& other) = default;
		PropertyID(PropertyID&& other) = default;
		PropertyID(const QString& str) { *static_cast<QString*>(this) = str; }

		PropertyID& operator =(const PropertyID& other) = default;
		PropertyID& operator =(PropertyID&& other) = default;
		PropertyID& operator =(const QString& str) { *static_cast<QString*>(this) = str; return *this; }
	};
}

#endif
