/******************************************************************************
 * File: PropertyVector.h
 * Date: 14.1.2018
 *****************************************************************************/

#ifndef PROPERTYVECTOR_H
#define PROPERTYVECTOR_H

#include "common/ObjectVector.h"
#include "Property.h"

namespace grndr
{
	class PropertyVector : public ObjectVector<PropertyBase>
	{
	public:
		static const char* Serialization_Group;
		static const char* Serialization_Element;

	public:
		void copyValues(const PropertyVector& properties);

		template<typename PropType>
		PropType* property(typename vector_type::size_type pos) const;
		template<typename PropType>
		PropType* property(PropertyID id) const;

		pointer_type selectByID(PropertyID id) const;
	};
}

#include "PropertyVector.impl.h"

#endif
