/******************************************************************************
 * File: SerializationContext.impl.h
 * Date: 12.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SerializationContext.h"

template<typename ObjType>
int SerializationContext::addObject(const ObjType* obj, std::vector<const ObjType*>& vec)
{
	auto index = getObjectIndex(obj, vec);

	if (index == -1)
	{
		vec.push_back(obj);
		index = vec.size() - 1;
	}

	return index;
}

template<typename ObjType>
int SerializationContext::getObjectIndex(const ObjType* obj, const std::vector<const ObjType*>& vec) const
{
	auto it = std::find(vec.cbegin(), vec.cend(), obj);

	if (it != vec.cend())
		return it - vec.cbegin();
	else
		return -1;
}
