/******************************************************************************
 * File: SettingsContainer.impl.h
 * Date: 27.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SettingsContainer.h"

template<typename DataType>
DataType SettingsContainer::_child(QString name) const
{
	auto children = _children<DataType>(name);

	if (children.size() == 1)
		return children.front();
	else if (children.size() > 1)
		throw std::runtime_error{_EXCPT(QString{"The container '%1' is not unique"}.arg(name))};
	else
		return nullptr;
}

template<typename DataType>
const std::vector<DataType> SettingsContainer::_children(QString name) const
{
	std::vector<DataType> children;

	for (const auto& child : _childContainers)
	{
		if (name.isEmpty() || child->_name.compare(name, Qt::CaseInsensitive) == 0)
			children.push_back(child.get());
	}

	return children;
}
