/******************************************************************************
 * File: EngineController.h
 * Date: 21.2.2018
 *****************************************************************************/

#ifndef ENGINECONTROLLER_H
#define ENGINECONTROLLER_H

#include "GenericController.h"
#include "engine/EngineExecutionContext.h"

#include <opencv2/core.hpp>

namespace grndr
{
	class Engine;
	class Label;
	class Block;
	class Port;

	class EngineController : public GenericController
	{
		Q_OBJECT

	public:
		EngineController(Engine* engine);

	public:
		void executeLabel(Label* label, const ImageReference* activeImageReference, Engine::ExecutionMode mode) const;
		cv::Mat executeLabelEx(Label* label, const Port* port, const ImageReference* activeImageReference, Engine::ExecutionMode mode) const;

	private:
		Engine* _engine{nullptr};
	};
}

#endif
