/******************************************************************************
 * File: GenericController.h
 * Date: 08.2.2018
 *****************************************************************************/

#ifndef GENERICCONTROLLER_H
#define GENERICCONTROLLER_H

#include <QObject>

namespace grndr
{
	class GenericController : public QObject
	{
		Q_OBJECT

	public:
		GenericController(QString typeName);

	protected:
		template<typename Functor, typename... Args>
		auto callControllerFunction(QString action, Functor fnc, Args... args) const -> decltype(fnc(args...));

		virtual bool canCallControllerFunction() const { return true; }
		virtual void controllerFunctionCalled() const { }

		void showControllerError(QString action, QString error) const;

	protected:
		bool _suppressErrors{false};

	private:
		QString _controllerTypeName{""};
	};
}

#include "GenericController.impl.h"

#endif
