/******************************************************************************
 * File: EngineExceptions.h
 * Date: 21.2.2018
 *****************************************************************************/

#ifndef ENGINEEXCEPTIONS_H
#define ENGINEEXCEPTIONS_H

#include <QString>

#include "core/GrinderExceptions.h"

namespace grndr
{
	class Engine;
	class ProcessorBase;

	class EngineException : public GrinderException
	{
	public:
		EngineException(const Engine* engine, QString what);

	public:
		const Engine* engine() const { return _engine; }

	protected:
		const Engine* _engine{nullptr};
	};

	class ProcessorException : public EngineException
	{
	public:
		ProcessorException(const ProcessorBase* processor, QString what);

	public:
		const ProcessorBase* processor() const { return _processor; }

	protected:
		const ProcessorBase* _processor{nullptr};
	};
}

#endif
