/******************************************************************************
 * File: DataDescriptor.impl.h
 * Date: 19.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "DataDescriptor.h"

template<typename Type>
bool DataDescriptor::canConvertTypes(const std::vector<std::pair<Type, Type>> validConversions, Type typeFrom, Type typeTo) const
{
	if (typeFrom != typeTo)
	{
		for (auto conv : validConversions)
		{
			if (typeFrom == conv.first && typeTo == conv.second)
				return true;
		}

		return false;
	}
	else
		return true;
}
