/******************************************************************************
 * File: BinaryThresholdProcessor.cpp
 * Date: 21.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BinaryThresholdProcessor.h"

#include <opencv2/imgproc.hpp>

BinaryThresholdProcessor::BinaryThresholdProcessor(const Block* block) : Processor(block)
{

}

void BinaryThresholdProcessor::execute(EngineExecutionContext& ctx)
{
	Processor::execute(ctx);

	if (auto dataBlob = portData(ctx, _block->inPort()))
	{
		cv::Mat processedImage;
		cv::threshold(dataBlob->getMatrix(), processedImage, *_block->threshold(), *_block->targetValue(), *_block->invert() ? cv::THRESH_BINARY_INV : cv::THRESH_BINARY);

		ctx.setContextEntry(_block->outPort(), DataBlob{dataBlob->dataDescriptor(), std::move(processedImage)});
	}
}
