/******************************************************************************
 * File: ConvertToGrayscaleProcessor.cpp
 * Date: 22.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ConvertToGrayscaleProcessor.h"

#include <opencv2/imgproc.hpp>

ConvertToGrayscaleProcessor::ConvertToGrayscaleProcessor(const Block* block) : Processor(block)
{

}

void ConvertToGrayscaleProcessor::execute(EngineExecutionContext& ctx)
{
	Processor::execute(ctx);

	if (auto dataBlob = portData(ctx, _block->inPort()))
	{
		cv::Mat processedImage;
		cv::cvtColor(dataBlob->getMatrix(), processedImage, cv::COLOR_BGR2GRAY);

		ctx.setContextEntry(_block->outPort(), DataBlob{dataBlob->dataDescriptor(), std::move(processedImage)});
	}
}
