/******************************************************************************
 * File: InputProcessor.cpp
 * Date: 21.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "InputProcessor.h"
#include "engine/EngineExceptions.h"
#include "core/GrinderApplication.h"
#include "controller/ProjectController.h"

InputProcessor::InputProcessor(const Block* block) : Processor(block)
{

}

void InputProcessor::execute(EngineExecutionContext& ctx)
{
	Processor::execute(ctx);

	if (auto imageReference = _block->imageReference()->resolveImageReference())
		ctx.setContextEntry(_block->outPort(), DataBlob{getPortDataDescriptor(_block->outPort()), imageReference->loadImage()});
	else
		throwProcessorException("There currently is no active image");
}
