/******************************************************************************
 * File: DraftItemType.h
 * Date: 20.3.2018
 *****************************************************************************/

#ifndef DRAFTITEMTYPE_H
#define DRAFTITEMTYPE_H

#include <QString>

namespace grndr
{
	class DraftItemType final : public QString
	{
	public:
		static const char* Undefined; /* Invalid draft item */

		static const char* Line;
		static const char* Box;
		static const char* Pixels;

	public:
		using QString::QString;

		DraftItemType() = default;
		DraftItemType(const DraftItemType& other) = default;
		DraftItemType(DraftItemType&& other) = default;
		DraftItemType(const QString& str) { *static_cast<QString*>(this) = str; }

		DraftItemType& operator =(const DraftItemType& other) = default;
		DraftItemType& operator =(DraftItemType&& other) = default;
		DraftItemType& operator =(const QString& str) { *static_cast<QString*>(this) = str; return *this; }
	};
}

#endif
