/******************************************************************************
 * File: DraftItemVector.cpp
 * Date: 20.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "DraftItemVector.h"

const char* DraftItemVector::Serialization_Group = "DraftItems";
const char* DraftItemVector::Serialization_Element = "DraftItem";

DraftItemVector::DraftItemVector(const Layer* layer) :
	_layer{layer}
{
	if (!layer)
		throw std::invalid_argument{_EXCPT("layer may not be null")};
}

DraftItemVector::pointer_vec_type DraftItemVector::selectByType(DraftItemType type) const
{
	return select([type](auto item) { return item->getType() == type; });
}
