/******************************************************************************
 * File: ImageBuildItem.h
 * Date: 17.3.2018
 *****************************************************************************/

#ifndef IMAGEBUILDITEM_H
#define IMAGEBUILDITEM_H

#include <QObject>

#include "common/serialization/SerializationContext.h"
#include "common/serialization/DeserializationContext.h"

namespace grndr
{
	class ImageBuild;

	class ImageBuildItem : public QObject
	{
		Q_OBJECT

	public:
		static const char* Serialization_Value_Name;

	public:
		ImageBuildItem(ImageBuild* imageBuild, QString name = "");

	public:
		void initImageBuildItem();

	public:
		const ImageBuild* imageBuild() const { return _imageBuild; }
		ImageBuild* imageBuild() { return _imageBuild; }

		QString getName() const { return _name; }
		void setName(QString name) { if (_name != name) { _name = name; emit itemRenamed(); } }

	public:
		virtual void serialize(SerializationContext& ctx) const;
		virtual void deserialize(DeserializationContext& ctx);

	signals:
		void itemRenamed();

	protected:
		ImageBuild* _imageBuild{nullptr};

		QString _name{""};
	};
}

#endif
