/******************************************************************************
 * File: ImageExceptions.cpp
 * Date: 12.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageExceptions.h"
#include "Layer.h"

ImageException::ImageException(QString what) : GrinderException(what)
{

}

ImageBuildException::ImageBuildException(const ImageBuild* imageBuild, QString what) : ImageException(what),
	_imageBuild{imageBuild}
{

}

ImageEditorException::ImageEditorException(const ImageEditor* imageEditor, QString what) : ImageException(what),
	_imageEditor{imageEditor}
{

}

LayerException::LayerException(const Layer* layer, QString what) : ImageBuildException(layer ? layer->imageBuild() : nullptr, what),
	_layer{layer}
{

}

ImageTagException::ImageTagException(const ImageTag* imageTag, QString what) : ImageException(what),
	_imageTag{imageTag}
{

}
