/******************************************************************************
 * File: LayerItem.h
 * Date: 18.5.2018
 *****************************************************************************/

#ifndef LAYERITEM_H
#define LAYERITEM_H

#include "ItemRenderer.h"

namespace grndr
{
	class Layer;

	template<typename Base>
	class LayerItem : public Base
	{
	public:
		using base_type = Base;

	public:
		LayerItem(Layer* layer);

	public:
		virtual std::unique_ptr<ItemRenderer> createRenderer(const ItemRenderer::RendererStyle& rendererStyle) const = 0;

	public:
		Layer* layer() { return _layer; }
		const Layer* layer() const { return _layer; }

	protected:
		Layer* _layer{nullptr};
	};
}

#include "LayerItem.impl.h"

#endif
