/******************************************************************************
 * File: LayerPixels.h
 * Date: 18.5.2018
 *****************************************************************************/

#ifndef LAYERPIXELS_H
#define LAYERPIXELS_H

#include <QObject>

#include "LayerItem.h"
#include "LayerPixelsData.h"

namespace grndr
{
	class Layer;
	class DraftItem;

	class LayerPixels : public LayerItem<QObject>
	{
		Q_OBJECT

	public:
		static const char* Serialization_Group;

	public:
		LayerPixels(Layer* layer);

	public:
		void renderDraftItems(const std::vector<DraftItem*>& draftItems, const ItemRenderer::RendererStyle& rendererStyle);

	public:
		virtual std::unique_ptr<ItemRenderer> createRenderer(const ItemRenderer::RendererStyle& rendererStyle) const override;

	public:
		LayerPixelsData& data() { return _pixelsData; }
		const LayerPixelsData& data() const { return _pixelsData; }

	public:
		void serialize(SerializationContext& ctx) const;
		void deserialize(DeserializationContext& ctx);

	private:
		LayerPixelsData _pixelsData;
	};
}

#endif
