/******************************************************************************
 * File: LayerVector.cpp
 * Date: 17.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "LayerVector.h"

const char* LayerVector::Serialization_Group = "Layers";
const char* LayerVector::Serialization_Element = "Layer";

LayerVector::LayerVector(const ImageBuild* imageBuild) :
	_imageBuild{imageBuild}
{
	if (!imageBuild)
		throw std::invalid_argument{_EXCPT("imageBuild may not be null")};
}

LayerVector::pointer_type LayerVector::selectByName(QString name, bool caseSensitive) const
{
	return selectFirst([name, caseSensitive](auto layer) { return layer->getName().compare(name, caseSensitive ? Qt::CaseSensitive : Qt::CaseInsensitive) == 0; });
}
