/******************************************************************************
 * File: PixelsDraftItem.h
 * Date: 29.5.2018
 *****************************************************************************/

#ifndef PIXELSDRAFTITEM_H
#define PIXELSDRAFTITEM_H

#include "image/DraftItem.h"
#include "image/LayerPixelsData.h"

namespace grndr
{
	class PixelsDraftItem : public DraftItem
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		PixelsDraftItem(Layer* layer);

	public:
		virtual std::unique_ptr<ItemRenderer> createRenderer(const ItemRenderer::RendererStyle& rendererStyle) const override;

	public:
		LayerPixelsData& pixelsData() { return _pixelsData; }
		const LayerPixelsData& pixelsData() const { return _pixelsData; }

		auto showBox() { return dynamic_cast<BoolProperty*>(_showBox.get()); }
		auto showBox() const { return dynamic_cast<const BoolProperty*>(_showBox.get()); }
		auto boxMargin() { return dynamic_cast<UIntProperty*>(_boxMargin.get()); }
		auto boxMargin() const { return dynamic_cast<const UIntProperty*>(_boxMargin.get()); }
		auto boxLineWidth() { return dynamic_cast<UIntProperty*>(_boxLineWidth.get()); }
		auto boxLineWidth() const { return dynamic_cast<const UIntProperty*>(_boxLineWidth.get()); }

	public:
		virtual void serialize(SerializationContext& ctx) const override;
		virtual void deserialize(DeserializationContext& ctx) override;

	protected:
		virtual void createProperties() override;

	private:
		LayerPixelsData _pixelsData;

		std::shared_ptr<PropertyBase> _showBox;
		std::shared_ptr<PropertyBase> _boxMargin;
		std::shared_ptr<PropertyBase> _boxLineWidth;
	};
}

#endif
