/******************************************************************************
 * File: ImageTagsAllotmentProperty.cpp
 * Date: 3.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageTagsAllotmentProperty.h"
#include "image/ImageTag.h"
#include "ui/properties/editors/ImageTagsAllotmentPropertyEditor.h"

void ImageTagsAllotmentProperty::initProperty()
{
	ObjectProperty::initProperty();

	// Whenever the allotment has changed, notify the property about this
	connect(&_object, &ImageTagsAllotment::allotmentChanged, this, &ImageTagsAllotmentProperty::objectModified);
}

QWidget* ImageTagsAllotmentProperty::createEditor(QWidget* parent)
{
	return new ImageTagsAllotmentPropertyEditor{this, parent};
}

QString ImageTagsAllotmentProperty::toString() const
{
	QStringList tagNames;

	for (const auto& imageTag : _object.allottedTags())
		tagNames << imageTag->getName();

	if (!tagNames.isEmpty())
		return tagNames.join(", ");
	else
		return "No tags";
}
