/******************************************************************************
 * File: BoxDraftItemRenderer.cpp
 * Date: 21.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BoxDraftItemRenderer.h"
#include "util/MathUtils.h"

void BoxDraftItemRenderer::render(QPainter* painter, RenderMode mode, RenderFlags flags)
{
	painter->save();

	auto rect = QRect{getItemPosition(mode), *_draftItem->boxSize()};

	// Draw the selection background as an outer glow
	if (flags.testFlag(RenderFlag::Selected))
	{
		painter->save();
		painter->setPen(createSelectionPen(*_draftItem->lineWidth(), flags.testFlag(RenderFlag::Inactive)));
		painter->setOpacity(_rendererStyle.selectionOpacity);
		painter->drawRect(rect);
		painter->restore();
	}

	// Draw the box
	painter->setPen(createStandardPen(*_draftItem->lineWidth()));
	painter->drawRect(rect);

	if (*_draftItem->solidBox())
		painter->fillRect(rect, *_draftItem->primaryColor());

	// Draw the item's decoration (direction, tags etc.)
	renderDecoration(painter, rect, flags);

	painter->restore();
}
