/******************************************************************************
 * File: LayerPixelsRenderer.h
 * Date: 18.5.2018
 *****************************************************************************/

#ifndef LAYERPIXELSRENDERER_H
#define LAYERPIXELSRENDERER_H

#include "image/ItemRenderer.h"

namespace grndr
{
	class LayerPixelsData;

	class LayerPixelsRenderer : public ItemRenderer
	{
		Q_OBJECT

	public:
		LayerPixelsRenderer(const LayerPixelsData* pixelsData, const RendererStyle& rendererStyle);

	public:
		QPoint getPixelsOffset() const { return _pixelsOffset; }
		void setPixelsOffset(QPoint pos) { _pixelsOffset = pos; }

	public:
		virtual void render(QPainter* painter, RenderMode mode, RenderFlags flags) override;
		virtual QPainterPath shape(RenderFlags flags) const override;

	protected:
		virtual QPoint getItemPosition(RenderMode mode) const override { Q_UNUSED(mode); return _pixelsOffset; }

	private:
		void updateShape();

	private:
		const LayerPixelsData* _pixelsData{nullptr};
		QPoint _pixelsOffset{0, 0};
		QPainterPath _pixelsShape;
	};
}

#endif
