/******************************************************************************
 * File: main.cpp
 * Date: 11.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "core/GrinderApplication.h"

int main(int argc, char *argv[])
{
	InstallSignalHandlers();

	// Add additional search paths for Qt libraries/plugins
#if !defined(Q_OS_OSX)
	QString	libraryDir = "lib";

	if (argc >= 1)
	{
		QFileInfo fi(argv[0]);
		libraryDir = QFileInfo{fi.absolutePath(), "lib"}.absoluteFilePath();
	}

	QCoreApplication::addLibraryPath(libraryDir);
	qputenv("QT_PLUGIN_PATH", libraryDir.toLatin1());
#endif

	GrinderApplication app{argc, argv};

	try {
		return app.run();
	} catch (std::exception& e) {
		ShowExceptionMessage(e.what());
		throw;
	}
	catch (...) {
		ShowExceptionMessage("");
		throw;
	}
}
