/******************************************************************************
 * File: BlockCategory.h
 * Date: 24.1.2018
 *****************************************************************************/

#ifndef BLOCKCATEGORY_H
#define BLOCKCATEGORY_H

#include <vector>
#include <map>
#include <QString>

#include "BlockType.h"

namespace grndr
{
	class BlockCategory : public QString
	{
	public:
		static const char* Undefined;

		static const char* Input;
		static const char* Output;

		static const char* Conversion;
		static const char* Thresholding;

		static const char* Annotation;

	public:
		using QString::QString;

		BlockCategory() = default;
		BlockCategory(const BlockCategory& other) = default;
		BlockCategory(BlockCategory&& other) = default;
		BlockCategory(const QString& str) { *static_cast<QString*>(this) = str; }

		BlockCategory& operator =(const BlockCategory& other) = default;
		BlockCategory& operator =(BlockCategory&& other) = default;
		BlockCategory& operator =(const QString& str) { *static_cast<QString*>(this) = str; return *this; }
	};
}

#endif
