/******************************************************************************
 * File: BlockType.h
 * Date: 15.1.2018
 *****************************************************************************/

#ifndef BLOCKTYPE_H
#define BLOCKTYPE_H

#include <QString>

namespace grndr
{
	class BlockType final : public QString
	{
	public:
		static const char* Undefined; /* Invalid block */

		static const char* Input;
		static const char* Output;

		static const char* ConvertToGrayscale;

		static const char* BinaryThreshold;

		static const char* ImageTags;

	public:
		using QString::QString;

		BlockType() = default;
		BlockType(const BlockType& other) = default;
		BlockType(BlockType&& other) = default;
		BlockType(const QString& str) { *static_cast<QString*>(this) = str; }

		BlockType& operator =(const BlockType& other) = default;
		BlockType& operator =(BlockType&& other) = default;
		BlockType& operator =(const QString& str) { *static_cast<QString*>(this) = str; return *this; }
	};
}

#endif
