/******************************************************************************
 * File: BlockVector.cpp
 * Date: 15.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BlockVector.h"

const char* BlockVector::Serialization_Group = "Blocks";
const char* BlockVector::Serialization_Element = "Block";

BlockVector::BlockVector(const Pipeline* pipeline) :
	_pipeline{pipeline}
{
	if (!pipeline)
		throw std::invalid_argument{_EXCPT("pipeline may not be null")};
}

BlockVector::pointer_vec_type BlockVector::selectByType(BlockType type) const
{
	return select([type](auto block) { return block->getType() == type; });
}

BlockVector::pointer_type BlockVector::selectByName(QString name, bool caseSensitive) const
{
	return selectFirst([name, caseSensitive](auto block) { return block->getName().compare(name, caseSensitive ? Qt::CaseSensitive : Qt::CaseInsensitive) == 0; });
}
