/******************************************************************************
 * File: PipelineExceptions.cpp
 * Date: 15.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PipelineExceptions.h"
#include "PipelineItem.h"
#include "Block.h"

PipelineException::PipelineException(const Pipeline* pipeline, QString what) : GrinderException(what),
	_pipeline{pipeline}
{

}

PipelineItemException::PipelineItemException(const PipelineItem* item, QString what) : PipelineException(item ? item->pipeline() : nullptr, what),
	_pipelineItem{item}
{

}

BlockException::BlockException(const Block* block, QString what) : PipelineItemException(block, what),
	_block{block}
{

}

PortException::PortException(const Port* port, QString what) : BlockException(port->block(), what),
	_port{port}
{

}
