/******************************************************************************
 * File: PipelineItem.h
 * Date: 13.1.2018
 *****************************************************************************/

#ifndef PIPELINEITEM_H
#define PIPELINEITEM_H

#include "common/properties/PropertyObject.h"

namespace grndr
{
	class Pipeline;

	class PipelineItem : public PropertyObject
	{
		Q_OBJECT

	public:
		static const char* Serialization_Value_Name;

	public:
		PipelineItem(Pipeline* pipeline, QString name = "");

	public:
		void initPipelineItem();

	public:
		const Pipeline* pipeline() const { return _pipeline; }
		Pipeline* pipeline() { return _pipeline; }

		QString getName() const { return _name; }
		void setName(QString name) { if (_name != name) { _name = name; emit itemRenamed(); } }

	public:
		virtual void serialize(SerializationContext& ctx) const;
		virtual void deserialize(DeserializationContext& ctx);

	signals:
		void itemRenamed();

	protected:
		Pipeline* _pipeline{nullptr};

		QString _name{""};
	};
}

#endif
