/******************************************************************************
 * File: PipelineManager.h
 * Date: 16.1.2018
 *****************************************************************************/

#ifndef PIPELINEMANAGER_H
#define PIPELINEMANAGER_H

#include <QObject>

#include "PipelineVector.h"

namespace grndr
{
	class PipelineManager : public QObject
	{
		Q_OBJECT

	public:
		std::shared_ptr<Pipeline> createPipeline(QString name);
		void removePipeline(QString name);
		void removePipeline(const Pipeline* pipeline);

	public:
		const PipelineVector& pipelines() const { return _pipelines; }

	signals:
		void pipelineCreated(const std::shared_ptr<Pipeline>&);
		void pipelineRemoved(const std::shared_ptr<Pipeline>&);

	private:
		PipelineVector _pipelines;
	};
}

#endif
