/******************************************************************************
 * File: PortType.h
 * Date: 15.1.2018
 *****************************************************************************/

#ifndef PORTTYPE_H
#define PORTTYPE_H

#include <QString>

namespace grndr
{
	class PortType final : public QString
	{
	public:
		static const char* Undefined; /* Invalid port */

		static const char* GenericIn;
		static const char* GenericOut;

		static const char* ImageIn;
		static const char* ImageOut;
		static const char* ImageTagsIn;
		static const char* ImageTagsOut;

	public:
		using QString::QString;

		PortType() = default;
		PortType(const PortType& other) = default;
		PortType(PortType&& other) = default;
		PortType(const QString& str) { *static_cast<QString*>(this) = str; }

		PortType& operator =(const PortType& other) = default;
		PortType& operator =(PortType&& other) = default;
		PortType& operator =(const QString& str) { *static_cast<QString*>(this) = str; return *this; }
	};
}

#endif
