/******************************************************************************
 * File: PortVector.cpp
 * Date: 15.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PortVector.h"

const char* PortVector::Serialization_Group = "Ports";
const char* PortVector::Serialization_Element = "Port";

PortVector::PortVector(const Block* parent) :
	_block{parent}
{
	if (!parent)
		throw std::invalid_argument{_EXCPT("parent may not be null")};
}

PortVector::pointer_type PortVector::selectByType(PortType type) const
{
	return selectFirst([type](auto port) { return port->getType() == type; });
}

PortVector::pointer_vec_type PortVector::selectByDirection(Port::Direction dir) const
{
	return select([dir](auto port) { return port->getDirection() == dir; });
}
