/******************************************************************************
 * File: BinaryThresholdBlock.h
 * Date: 20.2.2018
 *****************************************************************************/

#ifndef BINARYTHRESHOLDBLOCK_H
#define BINARYTHRESHOLDBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class BinaryThresholdBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		BinaryThresholdBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto threshold() { return dynamic_cast<UIntProperty*>(_threshold.get()); }
		auto threshold() const { return dynamic_cast<const UIntProperty*>(_threshold.get()); }
		auto targetValue() { return dynamic_cast<UIntProperty*>(_targetValue.get()); }
		auto targetValue() const { return dynamic_cast<const UIntProperty*>(_targetValue.get()); }
		auto invert() { return dynamic_cast<BoolProperty*>(_invert.get()); }
		auto invert() const { return dynamic_cast<const BoolProperty*>(_invert.get()); }

		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _threshold;
		std::shared_ptr<PropertyBase> _targetValue;
		std::shared_ptr<PropertyBase> _invert;

		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
