/******************************************************************************
 * File: ConvertToGrayscaleBlock.cpp
 * Date: 22.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ConvertToGrayscaleBlock.h"
#include "engine/processors/ConvertToGrayscaleProcessor.h"

const BlockType ConvertToGrayscaleBlock::type_value = BlockType::ConvertToGrayscale;
const BlockCategory ConvertToGrayscaleBlock::category_value = BlockCategory::Conversion;

ConvertToGrayscaleBlock::ConvertToGrayscaleBlock(Pipeline* pipeline, QString name) : Block(pipeline, type_value, category_value, name)
{

}

std::unique_ptr<ProcessorBase> ConvertToGrayscaleBlock::createProcessor() const
{
	return std::make_unique<ConvertToGrayscaleProcessor>(this);
}

void ConvertToGrayscaleBlock::createPorts()
{
	DataDescriptors inPortDataDescs = {DataDescriptor::imageDescriptor(true, DataDescriptor::ValueType::Any), DataDescriptor::imageDescriptor(false, DataDescriptor::ValueType::Any)};
	_inPort = createPort(PortType::ImageIn, Port::Direction::In, inPortDataDescs, "In");

	DataDescriptors outPortDataDescs = {DataDescriptor::imageDescriptor(false, DataDescriptor::ValueType::Adaptive)};
	_outPort = createPort(PortType::ImageOut, Port::Direction::Out, outPortDataDescs, "Out");
}
