/******************************************************************************
 * File: ConvertToGrayscaleBlock.h
 * Date: 22.2.2018
 *****************************************************************************/

#ifndef CONVERTTOGRAYSCALEBLOCK_H
#define CONVERTTOGRAYSCALEBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class ConvertToGrayscaleBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		ConvertToGrayscaleBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createPorts() override;

	private:
		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _outPort;
	};
}

#endif
