/******************************************************************************
 * File: ImageTagsBlock.h
 * Date: 03.2.2018
 *****************************************************************************/

#ifndef IMAGETAGSBLOCK_H
#define IMAGETAGSBLOCK_H

#include "pipeline/Block.h"
#include "image/properties/ImageTagsProperty.h"

namespace grndr
{
	class ImageTagsBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		ImageTagsBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual void verifyConnection(const Port* src, const Port* dest) const override;

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto imageTags() { return dynamic_cast<ImageTagsProperty*>(_imageTags.get()); }
		auto imageTags() const { return dynamic_cast<const ImageTagsProperty*>(_imageTags.get()); }

		Port* imageTagsPort() { return _imageTagsPort.get(); }
		const Port* imageTagsPort() const { return _imageTagsPort.get(); }

	protected:
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _imageTags;

		std::shared_ptr<Port> _imageTagsPort;
	};
}

#endif
