/******************************************************************************
 * File: InputBlock.h
 * Date: 03.2.2018
 *****************************************************************************/

#ifndef INPUTBLOCK_H
#define INPUTBLOCK_H

#include "pipeline/Block.h"
#include "project/properties/ImageReferenceProperty.h"

namespace grndr
{
	class InputBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		InputBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		auto imageReference() { return dynamic_cast<ImageReferenceProperty*>(_imageReference.get()); }
		auto imageReference() const { return dynamic_cast<const ImageReferenceProperty*>(_imageReference.get()); }

		Port* outPort() { return _outPort.get(); }
		const Port* outPort() const { return _outPort.get(); }

	protected:
		virtual void createProperties() override;
		virtual void createPorts() override;

	private:
		std::shared_ptr<PropertyBase> _imageReference;

		std::shared_ptr<Port> _outPort;
	};
}

#endif
