/******************************************************************************
 * File: OutputBlock.h
 * Date: 15.2.2018
 *****************************************************************************/

#ifndef OUTPUTBLOCK_H
#define OUTPUTBLOCK_H

#include "pipeline/Block.h"

namespace grndr
{
	class OutputBlock : public Block
	{
		Q_OBJECT

	public:
		static const BlockType type_value;
		static const BlockCategory category_value;

	public:
		OutputBlock(Pipeline* pipeline, QString name = "");

	public:
		virtual std::unique_ptr<ProcessorBase> createProcessor() const override;

	public:
		Port* inPort() { return _inPort.get(); }
		const Port* inPort() const { return _inPort.get(); }
		Port* imageTagsPort() { return _imageTagsPort.get(); }
		const Port* imageTagsPort() const { return _imageTagsPort.get(); }

	protected:
		virtual void createPorts() override;

	private:
		std::shared_ptr<Port> _inPort;
		std::shared_ptr<Port> _imageTagsPort;
	};
}

#endif
