/******************************************************************************
 * File: ProjectExceptions.h
 * Date: 07.2.2018
 *****************************************************************************/

#ifndef PROJECTEXCEPTIONS_H
#define PROJECTEXCEPTIONS_H

#include <QString>

#include "core/GrinderExceptions.h"

namespace grndr
{
	class Project;
	class Label;
	class ImageReference;

	class ProjectException : public GrinderException
	{
	public:
		ProjectException(const Project* project, QString what);

	public:
		const Project* project() const { return _project; }

	protected:
		const Project* _project{nullptr};
	};

	class LabelException : public ProjectException
	{
	public:
		LabelException(const Label* label, QString what);

	public:
		const Label* label() const { return _label; }

	protected:
		const Label* _label{nullptr};
	};

	class ImageReferenceException : public ProjectException
	{
	public:
		ImageReferenceException(const ImageReference* imageRef, QString what);

	public:
		const ImageReference* imageReference() const { return _imageReference; }

	protected:
		const ImageReference* _imageReference{nullptr};
	};
}

#endif
