/******************************************************************************
 * File: ImageReferenceProperty.h
 * Date: 12.4.2018
 *****************************************************************************/

#ifndef IMAGEREFERENCEPROPERTY_H
#define IMAGEREFERENCEPROPERTY_H

#include "common/properties/Property.h"

namespace grndr
{
	class ImageReference;

	class ImageReferenceProperty : public Property<ImageReference*>
	{
		Q_OBJECT

	public:
		using Property<value_type>::Property;

	public:
		virtual void initProperty() override;

	public:
		virtual QWidget* createEditor(QWidget* parent) override;

	public:
		const ImageReference* resolveImageReference(const ImageReference* activeImageReference = nullptr) const;

	public:
		virtual QString toString() const override;

		virtual void serialize(SerializationContext& ctx) const override;
		virtual void deserialize(DeserializationContext& ctx) override;

	private slots:
		void imageReferenceRemoved(const std::shared_ptr<ImageReference>& imageReference);
	};
}

#endif
