/******************************************************************************
 * File: DragInfo.h
 * Date: 05.5.2018
 *****************************************************************************/

#ifndef DRAGINFO_H
#define DRAGINFO_H

#include <QImage>
#include <QVariant>

namespace grndr
{
	class DragInfo : public QObject
	{
		Q_OBJECT

	public:
		DragInfo(QObject* dragSource, QString mimeType, QString image, QSize imageSize = QSize{32, 32});

	public:
		void initiateDrag(QPoint pos, QVariant dragData = QVariant{});
		void processInitiatedDrag(QPoint pos);
		void cancelInitiatedDrag() { _dragInitiated = false; }

		void drag();

	public:
		bool isDragInitiated() const { return _dragInitiated; }

		QVariant& dragData() { return _dragData; }
		const QVariant& dragData() const { return _dragData; }

		void setDropAction(Qt::DropAction dropAction) { _dropAction = dropAction; }

	private:
		QObject* _dragSource{nullptr};
		QString _dragMimeType{""};
		QImage _dragImage;

		QVariant _dragData;

		Qt::DropAction _dropAction{Qt::CopyAction};

		bool _dragInitiated{false};
		QPoint _dragStartPosition;
	};
}

#endif
