/******************************************************************************
 * File: LongOperationIndicator.cpp
 * Date: 25.5.2018
 *****************************************************************************/

#include "Grinder.h"
#include "LongOperationIndicator.h"
#include "core/GrinderApplication.h"

LongOperationIndicator::LongOperationIndicator(QString operation, unsigned int operationSteps, bool canBeCanceled) :
	_activeWidget{QApplication::focusWidget()}, _progressDialog{operation, canBeCanceled ? "Cancel" : "", 0, static_cast<int>(operationSteps), nullptr, Qt::Dialog|Qt::WindowTitleHint}, _statusMessage{operation}
{
	_progressDialog.setWindowModality(Qt::ApplicationModal);
	_progressDialog.setMinimumDuration(0);
	_progressDialog.setValue(0);

	if (grinder()->mainWindow())
		grinder()->mainWindow()->setEnabled(false);
}

LongOperationIndicator::~LongOperationIndicator()
{
	if (grinder()->mainWindow())
		grinder()->mainWindow()->setEnabled(true);

	if (_activeWidget)
		_activeWidget->setFocus();
}

void LongOperationIndicator::setText(QString text)
{
	_progressDialog.setLabelText(text);
	_statusMessage.setMessage(text);
}
