/******************************************************************************
 * File: LongOperationIndicator.h
 * Date: 25.5.2018
 *****************************************************************************/

#ifndef LONGOPERATIONINDICATOR_H
#define LONGOPERATIONINDICATOR_H

#include <QProgressDialog>

#include "TemporaryStatusMessage.h"

namespace grndr
{
	class LongOperationIndicator
	{
	public:
		LongOperationIndicator(QString operation, unsigned int operationSteps = 1, bool canBeCanceled = false);
		~LongOperationIndicator();

	public:
		void setText(QString text);
		void stepProgress() { _progressDialog.setValue(_progressDialog.value() + 1); }
		void finish() { _progressDialog.setValue(_progressDialog.maximum()); }

		bool wasCanceled() const { return _progressDialog.wasCanceled(); }

	public:
		LongOperationIndicator& operator++() { stepProgress(); return *this; }
		LongOperationIndicator& operator++(int) { stepProgress(); return *this; }

	private:
		QWidget* _activeWidget{nullptr};
		QProgressDialog _progressDialog;
		TemporaryStatusMessage _statusMessage;
	};
}

#endif
