/******************************************************************************
 * File: CheckListDialog.h
 * Date: 25.4.2018
 *****************************************************************************/

#ifndef CHECKLISTDIALOG_H
#define CHECKLISTDIALOG_H

#include <QDialog>
#include <QListWidget>

namespace Ui
{
	class CheckListDialog;
}

namespace grndr
{
	class CheckListDialog : public QDialog
	{
		Q_OBJECT

	public:
		CheckListDialog(QString dialogTitle = "", bool acceptIfNoItemsChecked = false, QWidget* parent = nullptr);
		~CheckListDialog();

	public:
		template<typename ObjectType, typename ItemType, typename ContainerType>
		std::vector<ObjectType*> exec(const ContainerType& container, const std::vector<ObjectType*>& checkedObjects = {}, bool* accepted = nullptr);

	private:
		void setupUi();
		Ui::CheckListDialog *ui;

		QListWidget* _checkListWidget{nullptr};

	private:
		void setCheckListWidget(QListWidget* listWidget);

	private slots:
		void checkListItemChanged(QListWidgetItem* item);

	private:
		bool _acceptIfNoItemsChecked{false};
	};
}

#include "CheckListDialog.impl.h"

#endif
