/******************************************************************************
 * File: OptionsDialog.h
 * Date: 02.3.2018
 *****************************************************************************/

#ifndef OPTIONSDIALOG_H
#define OPTIONSDIALOG_H

#include <QDialog>

#include "core/GrinderSettings.h"

namespace Ui
{
	class OptionsDialog;
}

namespace grndr
{
	class OptionsDialog : public QDialog
	{
		Q_OBJECT

	public:
		OptionsDialog(QWidget *parent = nullptr);
		~OptionsDialog();

	public slots:
		virtual void accept() override;

	private slots:
		void on_chkGroupIntoTabs_toggled(bool checked);
		void on_chkStartUndocked_toggled(bool checked);

	private:
		void setupUi();
		Ui::OptionsDialog *ui;

	private:
		void applyGeneralOptions(bool save);
		void applyStartupOptions(bool save);
		void applyImageOptions(bool save);
		void applyImageEditorOptions(bool save);

	private:
		GrinderSettings::GeneralOptions _generalOptions;
		GrinderSettings::StartupOptions _startupOptions;
		GrinderSettings::ImageOptions _imageOptions;
		GrinderSettings::ImageEditorOptions _imageEditorOptions;
	};
}

#endif
