/******************************************************************************
 * File: GraphConnectionMessage.h
 * Date: 29.1.2018
 *****************************************************************************/

#ifndef GRAPHCONNECTIONMESSAGE_H
#define GRAPHCONNECTIONMESSAGE_H

#include "GraphNode.h"
#include "GraphStyle.h"

namespace grndr
{
	class GraphConnectionMessage : public GraphNode
	{
	public:
		GraphConnectionMessage(GraphScene* scene, QGraphicsItem *parent = nullptr);

	public:
		QString text() const { return _text; }
		void setText(QString text) { _text = text; prepareGeometryChange(); updateGeometry(); }

	public:
		virtual void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget) override;

	protected:
		virtual void updateGeometry() override;

		struct
		{
			QRectF _textRect;
		} _geometry;

	private:
		QString _text;

		const GraphStyle::ConnectionMessageStyle& _connectionStyle;
	};
}

#endif
