/******************************************************************************
 * File: GraphNode.cpp
 * Date: 22.1.2018
 *****************************************************************************/

#include "Grinder.h"
#include "GraphNode.h"
#include "GraphScene.h"
#include "GraphView.h"
#include "core/GrinderApplication.h"
#include "controller/PipelineController.h"
#include "util/UIUtils.h"
#include "res/Resources.h"

#include <QMenu>

GraphNode::GraphNode(GraphScene* scene, QGraphicsItem* parent) : VisualNode(scene, parent),
	_scene{scene}, _style{scene->view()->sceneStyle()}
{
	// Create node actions
	_deleteAction = createNodeAction("&Delete item(s)", FILE_ICON_DELETE, SLOT(deleteNode()), "Remove the selected items", "Del");
}

void GraphNode::deleteNode()
{
	grinder()->pipelineController().removeSelectedNodes();
}
