/******************************************************************************
 * File: GraphNode.h
 * Date: 22.1.2018
 *****************************************************************************/

#ifndef GRAPHNODE_H
#define GRAPHNODE_H

#include "ui/visscene/VisualNode.h"

namespace grndr
{
	class GraphScene;
	class GraphStyle;

	class GraphNode : public VisualNode
	{
		Q_OBJECT

	public:
		GraphNode(GraphScene* scene, QGraphicsItem* parent = nullptr);

	protected:
		virtual std::vector<QAction*> getNodeActions(QMenu& menu) const override { Q_UNUSED(menu); return {nullptr, _deleteAction}; }
		virtual std::vector<QAction*> getNodesActions(QMenu& menu) const override { Q_UNUSED(menu); return {_deleteAction}; }

	protected slots:
		void deleteNode();

	protected:
		GraphScene* _scene{nullptr};
		const GraphStyle& _style;

		QAction* _deleteAction;
	};
}

#endif
