/******************************************************************************
 * File: GraphWidget.cpp
 * Date: 02.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "GraphWidget.h"
#include "GraphView.h"
#include "GraphBlockList.h"
#include "ui/StyleSheet.h"

GraphWidget::GraphWidget(QWidget* parent) : QFrame(parent),
	_layout{new QGridLayout{this}}
{
	_layout->setContentsMargins(0, 0, 0, 0);
	_layout->setHorizontalSpacing(0);
	_layout->setVerticalSpacing(0);

	// Create the graph controls
	_graphView = new GraphView{};
	_layout->addWidget(_graphView, 0, 1);

	_graphBlockList = new GraphBlockList{};
	_layout->addWidget(_graphBlockList, 0, 0);
}
