/******************************************************************************
 * File: ImageEditor.h
 * Date: 27.3.2018
 *****************************************************************************/

#ifndef IMAGEEDITOR_H
#define IMAGEEDITOR_H

#include "controller/ImageEditorController.h"
#include "ImageEditorEnvironment.h"
#include "ImageEditorDockWidget.h"
#include "ImageEditorWidget.h"
#include "ImageEditorToolList.h"

namespace grndr
{
	class Block;

	class ImageEditor : public QObject
	{
		Q_OBJECT

	public:
		static const char* Serialization_Value_Block;

	public:
		ImageEditor();

	public:
		void setImageBuild(const std::shared_ptr<ImageBuild>& imageBuild);

	public:
		ImageEditorController& controller() { return _editorController; }
		const ImageEditorController& controller() const { return _editorController; }
		ImageEditorEnvironment& environment() { return _editorEnvironment; }
		const ImageEditorEnvironment& environment() const { return _editorEnvironment; }
		ImageEditorToolList& editorTools() { return _editorTools; }
		const ImageEditorToolList& editorTools() const { return _editorTools; }

		ImageEditorDockWidget* dockWidget() { return _editorDockWidget; }
		const ImageEditorDockWidget* dockWidget() const { return _editorDockWidget; }
		ImageEditorWidget* editorWidget() { return _editorWidget; }
		const ImageEditorWidget* editorWidget() const { return _editorWidget; }

	public:
		void serialize(SerializationContext& ctx) const;
		void deserialize(DeserializationContext& ctx);

	private:
		ImageEditorController _editorController;
		ImageEditorEnvironment _editorEnvironment;
		ImageEditorToolList _editorTools;

		ImageEditorDockWidget* _editorDockWidget{nullptr};
		ImageEditorWidget* _editorWidget{nullptr};		
	};
}

#endif
