/******************************************************************************
 * File: ImageEditorNode.h
 * Date: 21.3.2018
 *****************************************************************************/

#ifndef IMAGEEDITORNODE_H
#define IMAGEEDITORNODE_H

#include <memory>

#include "ui/visscene/VisualNode.h"
#include "ImageEditorComponent.h"
#include "image/ItemRenderer.h"

namespace grndr
{
	class ImageEditorScene;
	class ImageEditor;
	class ImageEditorStyle;
	class ItemRenderer;
	class DraftItem;

	class ImageEditorNode : public VisualNode, public ImageEditorComponent
	{
		Q_OBJECT

	public:
		ImageEditorNode(ImageEditorScene* scene, QGraphicsItem* parent = nullptr);

	public:
		virtual void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget) override;
		virtual QPainterPath shape() const override;

	protected:
		ItemRenderer::RenderFlags getRenderFlags() const;

	protected:
		ImageEditorScene* _scene{nullptr};

		std::unique_ptr<ItemRenderer> _renderer;
		const ImageEditorStyle& _style;
	};
}

#endif
