/******************************************************************************
 * File: ImageEditorPropertyWidget.h
 * Date: 23.3.2018
 *****************************************************************************/

#ifndef IMAGEEDITORPROPERTYWIDGET_H
#define IMAGEEDITORPROPERTYWIDGET_H

#include <QWidget>
#include <QGridLayout>

#include "ImageEditorComponent.h"
#include "common/properties/PropertyVector.h"

namespace grndr
{
	class ImageEditor;
	class ImageEditorTool;
	class ImageBuild;

	class ImageEditorPropertyWidget : public QWidget, public ImageEditorComponent
	{
		Q_OBJECT

	public:
		ImageEditorPropertyWidget(QWidget* parent = nullptr);

	public:
		void assignUiComponents(ImageEditor* imageEditor);

	public:
		void clear();

	private:
		void addProperties(const PropertyVector* properties);
		void addProperty(const std::shared_ptr<PropertyBase>& property);

	private slots:
		void populateProperties();

		void imageEditorToolChanged(const ImageEditorTool* tool);

		void imageBuildSwitching(ImageBuild* imageBuild);
		void imageBuildSwitched(ImageBuild* imageBuild);

	private:
		QGridLayout* _layout{nullptr};
	};
}

#endif
