/******************************************************************************
 * File: ImageEditorScene.impl.h
 * Date: 21.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageEditorScene.h"
#include "DraftItemNode.h"
#include "LayerPixelsNode.h"

template<typename ValType>
std::vector<ValType> ImageEditorScene::_findDraftItemNodes(const Layer* layer) const
{
	std::vector<ValType> nodes;

	for (const auto& node : items())
	{
		if (auto itemNode = dynamic_cast<DraftItemNode*>(node))
		{
			if (auto item = itemNode->draftItem().lock())
			{
				if (!layer || item->layer() == layer)
					nodes.push_back(itemNode);
			}
		}
	}

	return nodes;
}
template<typename ValType>
std::vector<ValType> ImageEditorScene::_findLayerPixelsNodes(const Layer* layer) const
{
	std::vector<ValType> nodes;

	for (const auto& node : items())
	{
		if (auto pixelsNode = dynamic_cast<LayerPixelsNode*>(node))
		{
			if (auto pixelsLayer = pixelsNode->layer().lock())
			{
				if (!layer || pixelsLayer.get() == layer)
					nodes.push_back(pixelsNode);
			}
		}
	}

	return nodes;
}
