/******************************************************************************
 * File: ImageEditorStyle.h
 * Date: 16.3.2018
 *****************************************************************************/

#ifndef IMAGEEDITORSTYLE_H
#define IMAGEEDITORSTYLE_H

#include <QMarginsF>
#include <QPalette>

#include "ui/visscene/VisualSceneStyle.h"
#include "image/ItemRenderer.h"

namespace grndr
{
	class ImageEditorStyle : public VisualSceneStyle
	{
	public:
		struct EditorStyle
		{
			QMarginsF editorMargins{100.0, 100.0, 100.0, 100.0};
		};

		struct ItemNodeStyle : public ItemRenderer::RendererStyle
		{

		};

		struct DragHandleStyle
		{
			QSizeF handleSize{15.0, 15.0};
			float radius{5.0};
			QColor outerBorderColor{255, 255, 255};
			float outerBorderWidth{3.0};
			QColor innerBorderColor{0, 0, 0};
			float innerBorderWidth{1.0};
		};

	public:
		ImageEditorStyle();

	public:
		const EditorStyle& getEditorStyle() const { return _editorStyle; }

		const ItemNodeStyle& getItemNodeStyle() const { return _itemNodeStyle; }
		const DragHandleStyle& getDragHandleStyle() const { return _dragHandleStyle; }

	private:
		EditorStyle _editorStyle;

		ItemNodeStyle _itemNodeStyle;
		DragHandleStyle _dragHandleStyle;
	};
}

#endif
