/******************************************************************************
 * File: ImageTagsDialog.cpp
 * Date: 18.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "ImageTagsDialog.h"
#include "ui_ImageTagsDialog.h"

ImageTagsDialog::ImageTagsDialog(ImageTags* imageTags, QWidget* parent) : QDialog(parent, Qt::Dialog|Qt::WindowTitleHint|Qt::WindowCloseButtonHint),
	ui{new Ui::ImageTagsDialog}, _imageTags{imageTags}
{
	if (!imageTags)
		throw std::invalid_argument{_EXCPT("imageTags may not be null")};

	setupUi();
}

ImageTagsDialog::~ImageTagsDialog()
{
	delete ui;
}

void ImageTagsDialog::setupUi()
{
	ui->setupUi(this);

	// Set up the various UI components
	ui->imageTagsList->assignImageTags(_imageTags);
	ui->imageTagsList->setupUi(static_cast<QMenu*>(nullptr), ui->imageTagsControlBar);
}
