/******************************************************************************
 * File: ImageTagsListWidget.h
 * Date: 01.5.2018
 *****************************************************************************/

#ifndef IMAGETAGSLISTWIDGET_H
#define IMAGETAGSLISTWIDGET_H

#include "BaseImageTagsListWidget.h"
#include "ui/DragInfo.h"
#include "ui/image/ImageEditorComponent.h"

#define IMAGETAGSLIST_DRAG_MIMETYPE	"application/x-imagetags"

namespace grndr
{
	class ImageBuild;

	class ImageTagsListWidget : public BaseImageTagsListWidget, public ImageEditorComponent
	{
		Q_OBJECT

	public:
		ImageTagsListWidget(QWidget* parent = nullptr);

	public:
		void assignUiComponents(ImageEditor* imageEditor);

	public:
		virtual ImageTagsListItem* addObject(ImageTag* imageTag, bool autoSelect = true, bool insertAtFront = false) override;

	protected:
		virtual void startDrag(Qt::DropActions supportedActions) override;

	private slots:
		void imageBuildSwitched(ImageBuild* imageBuild);

		void populateList();

	private:
		ImageBuild* _imageBuild{nullptr};	

		DragInfo _dragInfo;
	};
}

#endif
