/******************************************************************************
 * File: LayerPixelsNode.h
 * Date: 18.5.2018
 *****************************************************************************/

#ifndef LAYERPIXELSNODE_H
#define LAYERPIXELSNODE_H

#include "ImageEditorNode.h"

namespace grndr
{
	class Layer;
	class LayerPixels;

	class LayerPixelsNode : public ImageEditorNode
	{
		Q_OBJECT

	public:
		LayerPixelsNode(ImageEditorScene* scene, const std::shared_ptr<Layer>& layer, QGraphicsItem* parent = nullptr);

	public:
		std::weak_ptr<Layer>& layer() { return _layer; }
		const std::weak_ptr<Layer>& layer() const { return _layer; }

	public slots:
		void updateNode();

		void updateZOrder();
		void updateVisibility();

	protected:
		virtual void updateGeometry() override;

	private:
		std::weak_ptr<Layer> _layer;
	};
}

#endif
