/******************************************************************************
 * File: PixelsDraftItemNode.h
 * Date: 29.5.2018
 *****************************************************************************/

#ifndef PIXELSDRAFTITEMNODE_H
#define PIXELSDRAFTITEMNODE_H

#include "image/DraftItemType.h"
#include "ui/image/DraftItemNode.h"
#include "image/draftitems/PixelsDraftItem.h"

namespace grndr
{
	class PixelsDraftItemNode : public DraftItemNode
	{
		Q_OBJECT

	public:
		static const DraftItemType type_value;

	public:
		PixelsDraftItemNode(ImageEditorScene* scene, const std::shared_ptr<DraftItem>& item, QGraphicsItem* parent = nullptr);

	public:
		auto pixelsDraftItem() { return std::dynamic_pointer_cast<PixelsDraftItem>(_draftItem.lock()); }
		auto pixelsDraftItem() const { return std::dynamic_pointer_cast<const PixelsDraftItem>(_draftItem.lock()); }

	protected:
		virtual std::unique_ptr<InPlaceEditor> createInPlaceEditor() override { return nullptr; }

	protected:
		virtual QRect getBoundingRect() const override;
	};
}

#endif
