/******************************************************************************
 * File: LinearInPlaceEditor.h
 * Date: 28.3.2018
 *****************************************************************************/

#ifndef LINEARINPLACEEDITOR_H
#define LINEARINPLACEEDITOR_H

#include "ui/image/InPlaceEditor.h"
#include "common/properties/StandardProperties.h"

namespace grndr
{
	class LinearInPlaceEditor : public InPlaceEditor
	{
		Q_OBJECT

	public:
		LinearInPlaceEditor(ImageEditorScene* scene, DraftItemNode* draftItemNode, PointProperty* startPosition, PointProperty* endPosition);

	public:
		virtual void updateEditor() override;

	protected:
		virtual void dragHandleMoved(InPlaceEditorDragHandle* dragHandle, QPoint offset) override;

	private:
		void updateDragHandlePositions();

	private:
		PointProperty* _startPosition{nullptr};
		PointProperty* _endPosition{nullptr};

		InPlaceEditorDragHandle* _startDragHandle{nullptr};
		InPlaceEditorDragHandle* _endDragHandle{nullptr};
	};
}

#endif
