/******************************************************************************
 * File: ColorPickerTool.h
 * Date: 22.3.2018
 *****************************************************************************/

#ifndef COLORPICKERTOOL_H
#define COLORPICKERTOOL_H

#include "ui/image/ImageEditorTool.h"

namespace grndr
{
	class ColorPickerTool : public ImageEditorTool
	{
	public:
		static const char* tool_type;

	public:
		ColorPickerTool(ImageEditor* imageEditor);

	public:
		virtual void toolActivated(ImageEditorTool* prevTool) override;

	public:
		virtual QString getToolType() const override { return tool_type; }

	protected:
		virtual InputEventResult mousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult mouseReleased(const QGraphicsSceneMouseEvent* event) override;

	private:
		ImageEditorTool* _previousTool{nullptr};
		bool _switchToPreviousTool{false};
	};
}

#endif
