/******************************************************************************
 * File: EraserTool.h
 * Date: 21.5.2018
 *****************************************************************************/

#ifndef ERASERTOOL_H
#define ERASERTOOL_H

#include <QGraphicsProxyWidget>

#include "PaintbrushTool.h"

namespace grndr
{
	class EraserTool : public PaintbrushTool
	{
	public:
		static const char* tool_type;

	public:
		EraserTool(ImageEditor* imageEditor);

	public:
		virtual QString getToolType() const override { return tool_type; }

	protected:
		virtual void createProperties() override;

	protected:
		virtual InputEventResult rightMousePressed(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseMoved(const QGraphicsSceneMouseEvent* event) override;
		virtual InputEventResult rightMouseReleased(const QGraphicsSceneMouseEvent* event) override;

	private:
		QRubberBand* _rubberBand{nullptr};
		QGraphicsProxyWidget* _rubberBandNode{nullptr};
	};
}

#endif
