/******************************************************************************
 * File: RecentProjectsMenu.h
 * Date: 01.3.2018
 *****************************************************************************/

#ifndef RECENTPROJECTSMENU_H
#define RECENTPROJECTSMENU_H

#include <QMenu>

#include "common/MRUStringList.h"

namespace grndr
{
	class RecentProjectsMenu : public QMenu
	{
		Q_OBJECT

	public:
		using QMenu::QMenu;

	public:
		void setupUi(MRUStringList* recentProjects, std::function<void(QString)> loadProjectCallback);
		void updateUi();

	private slots:
		void loadRecentProject();

	private:
		MRUStringList* _recentProjects{nullptr};
		std::function<void(QString)> _loadProjectCallback{nullptr};
	};
}

#endif
