/******************************************************************************
 * File: AnglePropertyEditor.h
 * Date: 26.3.2018
 *****************************************************************************/

#ifndef ANGLEPROPERTYEDITOR_H
#define ANGLEPROPERTYEDITOR_H

#include "common/properties/types/AngleProperty.h"
#include "ui/widgets/AutoFocusWidget.h"
#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	class AnglePropertyEditor : public PropertyEditor<QWidget, AngleProperty>
	{
		Q_OBJECT

	public:
		AnglePropertyEditor(AngleProperty* property, QWidget *parent = nullptr);

	protected:
		virtual void applyPropertyValue() override;

	private slots:
		void angleDialChanged(int value);
		void angleValueChanged(int value);

	private:
		QDial* _angleDial{nullptr};
		AutoFocusSpinBox* _angleEdit{nullptr};
	};
}

#endif
