/******************************************************************************
 * File: DialogPropertyEditor.h
 * Date: 18.4.2018
 *****************************************************************************/

#ifndef DIALOGPROPERTYEDITOR_H
#define DIALOGPROPERTYEDITOR_H

#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	template<typename PropertyType = PropertyBase>
	class DialogPropertyEditor : public PropertyEditor<QWidget, PropertyType>
	{
	public:
		DialogPropertyEditor(PropertyType* property, QWidget *parent = nullptr);

	public:
		virtual void invokeDialog() = 0;

	protected:
		virtual void showEvent(QShowEvent* event) override;
		virtual void mouseDoubleClickEvent(QMouseEvent* event) override;

	protected:
		virtual void applyPropertyValue() override;

	protected:
		void setValueLabelText(QString text);

	private:
		void editPropertyClicked(bool checked);

	private:
		QLabel* _valueLabel{nullptr};
		QToolButton* _editButton{nullptr};
	};
}

#include "DialogPropertyEditor.impl.h"

#endif
