/******************************************************************************
 * File: DualIntPropertyEditor.h
 * Date: 23.3.2018
 *****************************************************************************/

#ifndef DUALINTPROPERTYEDITOR_H
#define DUALINTPROPERTYEDITOR_H

#include "common/Range.h"
#include "ui/widgets/AutoFocusWidget.h"
#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	template<class PropertyType>
	class DualIntPropertyEditor : public PropertyEditor<QWidget, PropertyType>
	{
	public:
		DualIntPropertyEditor(PropertyType* property, QString name1, QString name2, Range<int> range1, Range<int> range2, QWidget *parent = nullptr);

	protected:
		virtual void valueChanged(int value) { Q_UNUSED(value); valuesChanged(); }
		virtual void valuesChanged() = 0;

	protected:
		AutoFocusSpinBox* _spinBox1{nullptr};
		AutoFocusSpinBox* _spinBox2{nullptr};
	};
}

#include "DualIntPropertyEditor.impl.h"

#endif
