/******************************************************************************
 * File: IntPropertyEditor.h
 * Date: 28.5.2018
 *****************************************************************************/

#ifndef INTPROPERTYEDITOR_H
#define INTPROPERTYEDITOR_H

#include "common/properties/PropertyConstraint.h"
#include "ui/widgets/AutoFocusWidget.h"
#include "ui/properties/PropertyEditor.h"

namespace grndr
{
	class IntPropertyEditor : public PropertyEditor<AutoFocusSpinBox>
	{
		Q_OBJECT

	public:
		IntPropertyEditor(PropertyBase* property, const PropertyConstraints* constraints, QWidget* parent = nullptr);

	public:
		void setRangeFromConstraints(const PropertyConstraints& constraints);

	protected:
		virtual void applyPropertyValue() override;

	private slots:
		void valueChanged();
	};
}

#endif
