/******************************************************************************
 * File: PointPropertyEditor.cpp
 * Date: 07.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "PointPropertyEditor.h"
#include "util/StringConv.h"

PointPropertyEditor::PointPropertyEditor(PointProperty* property, QWidget* parent) : DualIntPropertyEditor(property, "x:", "y:", Range<int>::fullRange(), Range<int>::fullRange(), parent)
{
	applyPropertyValue();	
}

void PointPropertyEditor::applyPropertyValue()
{
	auto point = _property->getValue();

	_spinBox1->setValue(point.x());
	_spinBox2->setValue(point.y());
}

void PointPropertyEditor::valuesChanged()
{
	QPoint point;

	point.setX(_spinBox1->value());
	point.setY(_spinBox2->value());

	setPropertyValue(StringConv::convertValue(point));
}
