/******************************************************************************
 * File: TextPropertyEditor.cpp
 * Date: 07.3.2018
 *****************************************************************************/

#include "Grinder.h"
#include "TextPropertyEditor.h"

TextPropertyEditor::TextPropertyEditor(PropertyBase* property, QString inputMask, QWidget* parent) : PropertyEditor(property, parent)
{
	if (!inputMask.isEmpty())
		setValidator(new QRegExpValidator{QRegExp{inputMask}});

	applyPropertyValue();

	// Update the property whenever editing has been finished
	connect(this, &QLineEdit::editingFinished, this, &TextPropertyEditor::editingFinished);	
}

void TextPropertyEditor::applyPropertyValue()
{
	setText(getPropertyValue());
}

void TextPropertyEditor::editingFinished()
{
	setPropertyValue(text());
}
