/******************************************************************************
 * File: VisualSceneStyle.h
 * Date: 15.3.2018
 *****************************************************************************/

#ifndef VISUALSCENESTYLE_H
#define VISUALSCENESTYLE_H

#include <QSizeF>
#include <QColor>

namespace grndr
{
	class VisualSceneStyle
	{
	public:
		struct ViewStyle
		{
			QSizeF defaultSceneSize{0.0f, 0.0f};

			float zoomFactor{1.1};
			float minZoomLevel{0.2};
			float maxZoomLevel{5.0};
		};

		struct GridStyle
		{
			int size{20};

			QColor colorDark{200, 200, 200};
			QColor colorLight{230, 230, 230};
			int darkGridInterval{5};

			float maxZoomFactor{0.1f};
		};

	public:
		const ViewStyle& getViewStyle() const { return _viewStyle; }
		const GridStyle& getGridStyle() const { return _gridStyle; }

	protected:
		ViewStyle _viewStyle;
		GridStyle _gridStyle;
	};
}

#endif
