/******************************************************************************
 * File: ActiveObjectListWidget.h
 * Date: 25.4.2018
 *****************************************************************************/

#ifndef ACTIVEOBJECTLISTWIDGET_H
#define ACTIVEOBJECTLISTWIDGET_H

#include "ObjectListWidget.h"
#include "ActiveObjectListItem.h"

namespace grndr
{
	class ControlBar;
	class Label;

	template<typename ObjectType, typename ItemType>
	class ActiveObjectListWidget : public ObjectListWidget<ObjectType, ItemType>
	{
		static_assert(std::is_base_of<ActiveObjectListItem<ObjectType>, ItemType>::value, "ItemType must be derived from ActiveObjectListItem<ObjectType>");

	public:
		using object_type = ObjectType;
		using item_type = ItemType;

	public:
		using ObjectListWidget<ObjectType, ItemType>::ObjectListWidget;

	public:		
		object_type* activeObject() const;		

	protected:
		virtual void mouseDoubleClickEvent(QMouseEvent* event) override;

	protected:
		virtual void setCurrentObjectItem(item_type* item) override;

		virtual void switchToObjectItem(item_type* item, bool selectItem = true) { Q_UNUSED(item); Q_UNUSED(selectItem); }
		virtual void objectSwitched(object_type* obj);

		item_type* activeObjectItem() const;
	};
}

#include "ActiveObjectListWidget.impl.h"

#endif
