/******************************************************************************
 * File: AutoFocusWidget.h
 * Date: 28.5.2018
 *****************************************************************************/

#ifndef AUTOFOCUSWIDGET_H
#define AUTOFOCUSWIDGET_H

#include <QTimer>
#include <QLineEdit>
#include <QSpinBox>

namespace grndr
{
	template<typename Base>
	class AutoFocusWidget : public Base
	{
	public:
		using base_type = Base;

	public:
		using base_type::base_type;

	protected:
		virtual void focusInEvent(QFocusEvent* event) override { base_type::focusInEvent(event); QTimer::singleShot(0, this, &base_type::selectAll); }
	};

	using AutoFocusLineEdit = AutoFocusWidget<QLineEdit>;
	using AutoFocusSpinBox = AutoFocusWidget<QSpinBox>;
}

#endif
