/******************************************************************************
 * File: BaseListWidget.cpp
 * Date: 26.4.2018
 *****************************************************************************/

#include "Grinder.h"
#include "BaseListWidget.h"

void BaseListWidget::invertSelection()
{
	for (int i = 0; i < count(); ++i)
		item(i)->setSelected(!item(i)->isSelected());
}

void BaseListWidget::toggleCheckSelectedItems()
{
	auto selItems = selectedItems();

	if (!selItems.isEmpty())
	{
		bool checkItems = (selItems[0]->checkState() != Qt::Checked);

		for (auto item : selItems)
			item->setCheckState(checkItems ? Qt::Checked : Qt::Unchecked);
	}
}

void BaseListWidget::checkAllItems()
{
	for (int i = 0; i < count(); ++i)
		item(i)->setCheckState(Qt::Checked);
}

void BaseListWidget::uncheckAllItems()
{
	for (int i = 0; i < count(); ++i)
		item(i)->setCheckState(Qt::Unchecked);
}
