/******************************************************************************
 * File: ControlBar.h
 * Date: 07.2.2018
 *****************************************************************************/

#ifndef CONTROLBAR_H
#define CONTROLBAR_H

#include <QFrame>
#include <QHBoxLayout>

class QMenu;

namespace grndr
{
	class ControlBar : public QFrame
	{
		Q_OBJECT

	public:
		ControlBar(QWidget *parent = nullptr);

	public:
		void addWidget(QWidget* widget, Qt::Alignment alignment = 0);
		void addAction(QAction* action, Qt::ToolButtonStyle buttonStyle = Qt::ToolButtonFollowStyle, Qt::Alignment alignment = 0, QMenu* popupMenu = nullptr);
		void addSeparator(Qt::Alignment alignment = 0);

	public:
		void setDefaultAlignment(Qt::Alignment alignment) { _defaultAlignment = alignment; }
		void setDefaultToolButtonStyle(Qt::ToolButtonStyle style) { _defaultToolButtonStyle = style; }

	private:
		QHBoxLayout* _layout{nullptr};

		Qt::Alignment _defaultAlignment{Qt::AlignLeft};
		Qt::ToolButtonStyle _defaultToolButtonStyle{Qt::ToolButtonTextBesideIcon};
	};
}

#endif
