/******************************************************************************
 * File: MetaWidget.h
 * Date: 08.2.2018
 *****************************************************************************/

#ifndef METAWIDGET_H
#define METAWIDGET_H

#include <QMenu>
#include <memory>

namespace grndr
{
	template<typename Base>
	class MetaWidget : public Base
	{
	public:
		using widget_type = MetaWidget<Base>;
		using base_type = Base;

		using Base::Base;

	public:
		enum class AddActionsMode
		{
			MainMenu,
			ContextMenu,
			Toolbar,
		};

	public:
		template<typename T>
		int setupActions(T* widget, AddActionsMode mode) const;

		template<typename MenuType, typename BarType>
		void setupUi(MenuType* menu, BarType* toolbar) const;

	protected:
		virtual void contextMenuEvent(QContextMenuEvent* event) override;

	protected:
		virtual std::unique_ptr<QMenu> createContextMenu() const;

		virtual std::vector<QAction*> getActions(AddActionsMode mode) const { Q_UNUSED(mode); return {}; }
	};
}

#include "MetaWidget.impl.h"

#endif
