/******************************************************************************
 * File: DataUtils.cpp
 * Date: 16.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "DataUtils.h"

QString DataUtils::getDataDescriptorTypeName(DataDescriptor::StructureType type)
{
	switch (type)
	{
	case DataDescriptor::StructureType::Any:
		return "Arbitrary";

	case DataDescriptor::StructureType::Adaptive:
		return "Adaptive";

	case DataDescriptor::StructureType::Scalar:
		return "Scalar";

	case DataDescriptor::StructureType::Vector:
		return "Vector";

	case DataDescriptor::StructureType::Matrix:
		return "Matrix";

	default:
		return "Unknown";
	}
}

QString DataUtils::getDataDescriptorTypeName(DataDescriptor::FieldType type)
{
	switch (type)
	{
	case DataDescriptor::FieldType::Any:
		return "Arbitrary";

	case DataDescriptor::FieldType::Adaptive:
		return "Adaptive";

	case DataDescriptor::FieldType::Basic:
		return "Basic";

	case DataDescriptor::FieldType::Color:
		return "Colors";

	case DataDescriptor::FieldType::Point2D:
		return "2D points";

	case DataDescriptor::FieldType::Point3D:
		return "3D points";

	default:
		return "Unknown";
	}
}

QString DataUtils::getDataDescriptorTypeName(DataDescriptor::ValueType type)
{
	switch (type)
	{
	case DataDescriptor::ValueType::Any:
		return "Arbitrary";

	case DataDescriptor::ValueType::Adaptive:
		return "Adaptive";

	case DataDescriptor::ValueType::Int8:
		return "Integer (signed, 8 bit)";

	case DataDescriptor::ValueType::UInt8:
		return "Integer (unsigned, 8 bit)";

	case DataDescriptor::ValueType::Int16:
		return "Integer (signed, 16 bit)";

	case DataDescriptor::ValueType::UInt16:
		return "Integer (unsigned, 16 bit)";

	case DataDescriptor::ValueType::Int32:
		return "Integer (signed, 32 bit)";

	case DataDescriptor::ValueType::UInt32:
		return "Integer (unsigned, 32 bit)";

	case DataDescriptor::ValueType::Float:
		return "Real (single precision)";

	case DataDescriptor::ValueType::Double:
		return "Real (double precision)";

	default:
		return "Unknown";
	}
}
