/******************************************************************************
 * File: ImageUtils.h
 * Date: 10.2.2018
 *****************************************************************************/

#ifndef IMAGEUTILS_H
#define IMAGEUTILS_H

#include <QStringList>
#include <QPoint>

namespace grndr
{
	class ImageUtils final
	{
	public:
		static QStringList getSupportedFormats();
		static QStringList getSupportedFormatFilters();

		static std::vector<QPoint> getLinePoints(QPoint p0, QPoint p1) { return getLinePoints(p0.x(), p0.y(), p1.x(), p1.y()); }
		static std::vector<QPoint> getLinePoints(int xstart, int ystart, int xend, int yend);

	private:
		ImageUtils();
	};
}

#endif
