/******************************************************************************
 * File: MathUtils.h
 * Date: 27.3.2018
 *****************************************************************************/

#ifndef MATHUTILS_H
#define MATHUTILS_H

#include <QPoint>

namespace grndr
{
	class MathUtils final
	{
	public:
		static double vectorLength(double x, double y);

		template<typename T>
		static T clamp(T& val, T min, T max) { if (val < min) val = min; if (val > max) val = max; return val; }

	private:
		MathUtils() { }
	};
}

#endif
