/******************************************************************************
 * File: StringUtils.h
 * Date: 12.1.2018
 *****************************************************************************/

#ifndef STRINGUTILS_H
#define STRINGUTILS_H

#include <QString>
#include <functional>

namespace grndr
{
	class StringUtils final
	{
	public:
		static QString encodeEscapeCharacters(QString str, bool includeQuotes = true);
		static QString decodeEscapeCharacters(const QString& str, bool includeQuotes = true);

		static QString fileSizeToString(qint64 fileSize);

		template<typename ContainerType>
		static QString generateUniqueItemName(const ContainerType& container, QString name, std::function<QString(const typename ContainerType::value_type&)> nameGetter, bool caseSensitive = false, bool addSpaces = true);

	private:
		StringUtils() { }
	};	
}

#include "StringUtils.impl.h"

#endif
