/******************************************************************************
 * File: UIUtils.h
 * Date: 02.2.2018
 *****************************************************************************/

#ifndef UIUTILS_H
#define UIUTILS_H

#include <QAction>
#include <QFileDialog>

namespace grndr
{
	class UIUtils final
	{
	public:
		static QAction* createAction(QObject* owner, QString name, QString icon = "", const char* callback = nullptr, QString help = "", QString shortcut = "", Qt::ShortcutContext context = Qt::WidgetShortcut, QObject* receiver = nullptr);

		static QString askFileName(bool saveFileName, QString dlgName, QWidget* parent = nullptr, QString caption = "", QString filter = "", QString* selectedFilter = nullptr, QFileDialog::Options options = QFileDialog::Options{});
		static QStringList askFileNames(QString dlgName, QWidget* parent = nullptr, QString caption = "", QString filter = "", QString* selectedFilter = nullptr, QFileDialog::Options options = QFileDialog::Options{});

		static void removeChildrenFromLayout(QLayout* layout);

	private:
		UIUtils() { }
	};		
}

#endif
